'$DYNAMIC
OPTION _EXPLICIT
_TITLE "Example"
'$include:'..\fzxNGN_BASE_v2\fzxNGN_ini.bas'
'$include:'gameINI.bas'

'**********************************************************************************************
'   Setup Types and Variables
'**********************************************************************************************

TYPE tGL_TEXTURE
  glText AS _INTEGER64
  img AS LONG
  hash AS _INTEGER64
  id AS STRING * 64
END TYPE

$LET MRENDERJOINTS = FALSE
$LET MRENDERCOLLISIONS = FALSE
$LET MRENDERFZXAABB = FALSE
$LET MRENDERWIREFRAME = FALSE
$LET GLLIGHTS = FALSE

CONST cFSM_GLMODE_IDLE = 0
CONST cFSM_GLMODE_INIT = 1
CONST cFSM_GLMODE_RUN = 2


DIM SHARED AS tFZX_FSM glMode
DIM SHARED AS LONG bm(100) ' array texture bitmaps
DIM SHARED AS tGL_TEXTURE textures(0)
DIM SHARED AS tGAME game

SCREEN _NEWIMAGE(1024, 768, 32)

fzxInitFPS
fzxFSMChangeState glMode, cFSM_GLMODE_IDLE

_GLRENDER _BEHIND
DIM AS LONG iterations: iterations = 1

DO
  IF glMode.currentState = cFSM_GLMODE_RUN THEN animateScene game
  fzxImpulseStep __fzxFPSCount.dt, iterations
LOOP UNTIL INKEY$ = CHR$(27)

SYSTEM
'$include:'..\fzxNGN_BASE_v2\fzxNGN_BASE.bas'

'**********************************************************************************************
'    Scene Creation and Handling Ahead
'**********************************************************************************************

SUB animateScene (game AS tGAME)
  fzxSetBody cFZX_PARAMETER_POSITION, game.mixer, __fzxWorld.spawn.x, __fzxBody(game.mixer).fzx.position.y - (__fzxFPSCount.dt * 20)
  fzxSetBody cFZX_PARAMETER_ORIENT, game.mixer, __fzxBody(game.mixer).fzx.orient - (__fzxFPSCount.dt / 2), 0
  IF __fzxBody(game.mixer).fzx.orient < 0 THEN __fzxBody(game.mixer).fzx.orient = 2 * _PI
  IF __fzxBody(game.mixer).fzx.position.y < -200 THEN fzxSetBody cFZX_PARAMETER_POSITION, game.mixer, __fzxWorld.spawn.x, 50
END SUB

SUB buildScene (game AS tGAME)
  DIM AS LONG temp, iter
  loadSprites bm()

  '********************************************************
  '   Setup World
  '********************************************************

  fzxVector2DSet __fzxWorld.minusLimit, -2000, -2000
  fzxVector2DSet __fzxWorld.plusLimit, 2000, 2000
  fzxVector2DSet __fzxWorld.spawn, 0, 0
  fzxVector2DSet __fzxWorld.gravity, 0.0, 100.0
  fzxVector2DSet __fzxWorld.terrainPosition, 0.0, 0.0
  DIM o AS tFZX_VECTOR2d
  fzxVector2DMultiplyScalarND o, __fzxWorld.gravity, __fzxFPSCount.dt
  __fzxWorld.resting = fzxVector2DLengthSq(o) + cFZX_EPSILON

  '********************************************************
  '   Build Level
  '********************************************************
  DIM AS DOUBLE sf, df, rs
  sf = .1
  df = .1
  rs = 0.85

  __fzxCamera.bkImg = 11 ' background image loaded into texture array
  game.mixer = fzxCreateBoxBodyEx("mixer", 185, 10)
  fzxSetBody cFZX_PARAMETER_POSITION, game.mixer, __fzxWorld.spawn.x, __fzxWorld.spawn.y - 100
  fzxSetBody cFZX_PARAMETER_TEXTURE, game.mixer, 4, 0
  fzxSetBody cFZX_PARAMETER_STATIC, game.mixer, 1, 0
  fzxSetBody cFZX_PARAMETER_RESTITUTION, game.mixer, rs, 0
  fzxSetBody cFZX_PARAMETER_STATICFRICTION, game.mixer, sf, 0
  fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, game.mixer, df, 0


  temp = fzxCreateBoxBodyEx("floor", 200, 50)
  fzxSetBody cFZX_PARAMETER_POSITION, temp, __fzxWorld.spawn.x, __fzxWorld.spawn.y + 100
  fzxSetBody cFZX_PARAMETER_TEXTURE, temp, 4, 0
  fzxSetBody cFZX_PARAMETER_STATIC, temp, 1, 0
  fzxSetBody cFZX_PARAMETER_RESTITUTION, temp, rs, 0
  fzxSetBody cFZX_PARAMETER_STATICFRICTION, temp, sf, 0
  fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, temp, df, 0


  temp = fzxCreateBoxBodyEx("wall1", 10, 100)
  fzxSetBody cFZX_PARAMETER_POSITION, temp, __fzxWorld.spawn.x - 200, __fzxWorld.spawn.y - 50
  fzxSetBody cFZX_PARAMETER_TEXTURE, temp, 4, 0
  fzxSetBody cFZX_PARAMETER_STATIC, temp, 1, 0
  fzxSetBody cFZX_PARAMETER_RESTITUTION, temp, rs, 0
  fzxSetBody cFZX_PARAMETER_STATICFRICTION, temp, sf, 0
  fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, temp, df, 0


  temp = fzxCreateBoxBodyEx("wall2", 10, 100)
  fzxSetBody cFZX_PARAMETER_POSITION, temp, __fzxWorld.spawn.x + 200, __fzxWorld.spawn.y - 50
  fzxSetBody cFZX_PARAMETER_TEXTURE, temp, 4, 0
  fzxSetBody cFZX_PARAMETER_STATIC, temp, 1, 0
  fzxSetBody cFZX_PARAMETER_RESTITUTION, temp, rs, 0
  fzxSetBody cFZX_PARAMETER_STATICFRICTION, temp, sf, 0
  fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, temp, df, 0


  FOR iter = 0 TO 24
    temp = fzxCreateBoxBodyEx("b" + _TRIM$(STR$(iter)), 10, 10)
    fzxSetBody cFZX_PARAMETER_POSITION, temp, __fzxWorld.spawn.x + (RND * 150) + 10, __fzxWorld.spawn.y + (RND * 400) - 400
    fzxSetBody cFZX_PARAMETER_TEXTURE, temp, 4, 0
    fzxSetBody cFZX_PARAMETER_RESTITUTION, temp, rs, 0
    fzxSetBody cFZX_PARAMETER_STATICFRICTION, temp, sf, 0
    fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, temp, df, 0
    'fzxSetBody cFZX_PARAMETER_LIFETIME, temp, RND * 20 + 10, 0
  NEXT
  FOR iter = 25 TO 49
    temp = fzxCreateCircleBodyEx("b" + _TRIM$(STR$(iter)), 10)
    fzxSetBody cFZX_PARAMETER_POSITION, temp, __fzxWorld.spawn.x + (RND * 150) + 10, __fzxWorld.spawn.y + (RND * 400) - 400
    fzxSetBody cFZX_PARAMETER_TEXTURE, temp, 6, 0
    fzxSetBody cFZX_PARAMETER_RESTITUTION, temp, rs, 0
    fzxSetBody cFZX_PARAMETER_STATICFRICTION, temp, sf, 0
    fzxSetBody cFZX_PARAMETER_DYNAMICFRICTION, temp, df, 0
    'fzxSetBody cFZX_PARAMETER_LIFETIME, temp, RND * 20 + 10, 0
  NEXT

  __fzxCamera.position = __fzxBody(game.mixer).fzx.position
END SUB


'**********************************************************************************************
'   OPENGL LOOP
'**********************************************************************************************

SUB _______________OPENGL_LOOP: END SUB
SUB _GL STATIC
  SELECT CASE glMode.currentState
    CASE cFSM_GLMODE_IDLE:
      fzxFSMChangeState glMode, cFSM_GLMODE_INIT
    CASE cFSM_GLMODE_INIT:
      __fzxCamera.zoom = 1.5
      fzxCalculateFOV
      buildScene game
      fzxFSMChangeState glMode, cFSM_GLMODE_RUN
    CASE cFSM_GLMODE_RUN:
      glStuff
      renderBodies textures()
  END SELECT
  fzxHandleFPSGL
END SUB

SUB renderBodies (textures() AS tGL_TEXTURE) STATIC
  DIM i AS INTEGER
  DIM AS tFZX_VECTOR2d scSize, scMid, scUpperLeft, camUpperLeft, aabbUpperLeft, aabbSize, aabbHalfSize
  DIM AS LONG ub: ub = UBOUND(__fzxBody)
  DIM AS LONG uJ: uJ = UBOUND(__fzxJoints)
  fzxVector2DSet aabbSize, 40000, 40000
  fzxVector2DSet aabbHalfSize, aabbSize.x / 2, aabbSize.y / 2

  fzxVector2DSet scUpperLeft, 0, 0
  fzxVector2DSet scSize, _WIDTH, _HEIGHT

  fzxVector2DDivideScalarND scMid, scSize, 2
  fzxVector2DSubVectorND camUpperLeft, __fzxCamera.position, scMid

  $IF MRENDERWIREFRAME = FALSE THEN
    IF __fzxCamera.bkImg <> 0 THEN
      glDrawRectText textures(__fzxCamera.bkImg).glText, 0, 0, _WIDTH(textures(__fzxCamera.bkImg).img), _HEIGHT(textures(__fzxCamera.bkImg).img)
    END IF
  $END IF

  i = 0: DO WHILE i < ub
    IF __fzxBody(i).enable THEN
      'fzxAABB to cut down on rendering objects out of camera view
      fzxVector2DSubVectorND aabbUpperLeft, __fzxBody(i).fzx.position, aabbHalfSize
      IF fzxAABBOverlap(camUpperLeft.x, camUpperLeft.y, scSize.x, scSize.y, aabbUpperLeft.x, aabbUpperLeft.y, aabbSize.x, aabbSize.y) THEN
        IF __fzxBody(i).shape.ty = cFZX_SHAPE_CIRCLE THEN
          $IF MRENDERWIREFRAME = FALSE THEN
            renderTexturedCircle3d i, textures(), 1.0
          $ELSE
              renderWireFrameCircle i, _RGB32(0, 255, 0)
          $END IF
        ELSE IF __fzxBody(i).shape.ty = cFZX_SHAPE_POLYGON THEN
            $IF MRENDERWIREFRAME = FALSE THEN
              renderTexturedBox3d i, textures(), 1.0
            $ELSE
                renderWireFramePoly i
            $END IF
          END IF
        END IF
      END IF
    END IF
    i = i + 1
  LOOP
  $IF MRENDERJOINTS = TRUE THEN
      i = 0: DO WHILE i <= uJ
      IF __fzxJoints(i).render = 1 THEN renderJoints i
      i = i + 1: LOOP
  $END IF
  $IF MRENDERCOLLISIONS = TRUE THEN
      DIM AS tFZX_VECTOR2d tv
      DIM hitcount AS INTEGER
      hitcount = 0
      DO WHILE hitcount <= UBOUND(__fzxHits)
      fzxWorldToCameraEx __fzxHits(hitcount).position, tv
      glDrawCircle tv.x, tv.y, 4, _RGB(255, 0, 0), 8
      hitcount = hitcount + 1
      ' LOCATE 1: PRINT UBOUND(hits)
      LOOP
  $END IF


END SUB

SUB renderJoints (index AS LONG)
  DIM AS tFZX_VECTOR2d o1, o2

  fzxWorldToCameraEx __fzxBody(__fzxJoints(index).body1).fzx.position, o1
  fzxWorldToCameraEx __fzxBody(__fzxJoints(index).body2).fzx.position, o2

  glDrawLine o1, o2, __fzxJoints(index).wireframe_color, 5
END SUB

SUB renderWireFrameCircle (index AS LONG, c AS LONG)
  DIM AS tFZX_VECTOR2d o1, o2

  fzxWorldToCameraEx __fzxBody(index).fzx.position, o1
  glDrawCircle o1.x, o1.y, __fzxBody(index).shape.radius * __fzxCamera.zoom, c, 12
  o2.x = o1.x + (__fzxBody(index).shape.radius * __fzxCamera.zoom) * COS(__fzxBody(index).fzx.orient)
  o2.y = o1.y + (__fzxBody(index).shape.radius * __fzxCamera.zoom) * SIN(__fzxBody(index).fzx.orient)
  glDrawLine o1, o2, c, 1

END SUB

SUB renderWireFramePoly (index AS LONG)
  DIM vert(3) AS tFZX_VECTOR2d

  fzxGetBodyVert index, 0, vert(0)
  fzxVector2DAddVector vert(0), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(0), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(0)

  fzxGetBodyVert index, 1, vert(1)
  fzxVector2DAddVector vert(1), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(1), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(1)

  fzxGetBodyVert index, 2, vert(2)
  fzxVector2DAddVector vert(2), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(2), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(2)

  fzxGetBodyVert index, 3, vert(3)
  fzxVector2DAddVector vert(3), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(3), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(3)

  glDrawLine vert(0), vert(1), _RGB(0, 255, 0), 2
  glDrawLine vert(1), vert(2), _RGB(0, 255, 0), 2
  glDrawLine vert(2), vert(3), _RGB(0, 255, 0), 2
  glDrawLine vert(3), vert(0), _RGB(0, 255, 0), 2

END SUB

SUB renderTexturedCircle (index AS INTEGER, textures() AS tGL_TEXTURE)
  DIM vert(3) AS tFZX_VECTOR2d
  fzxVector2DSet vert(0), -__fzxBody(index).shape.radius, __fzxBody(index).shape.radius
  fzxVector2DSet vert(1), -__fzxBody(index).shape.radius, -__fzxBody(index).shape.radius
  fzxVector2DSet vert(2), __fzxBody(index).shape.radius, -__fzxBody(index).shape.radius
  fzxVector2DSet vert(3), __fzxBody(index).shape.radius, __fzxBody(index).shape.radius
  fzxWorldToCamera index, vert(0)
  fzxWorldToCamera index, vert(1)
  fzxWorldToCamera index, vert(2)
  fzxWorldToCamera index, vert(3)
  glDrawTexturedQuad textures(__fzxBody(index).shape.texture).glText, vert(3), vert(0), vert(1), vert(2)
END SUB

SUB renderTexturedCircle3d (index AS INTEGER, textures() AS tGL_TEXTURE, z AS DOUBLE)
  DIM vert(3) AS tFZX_VECTOR2d
  fzxVector2DSet vert(0), -__fzxBody(index).shape.radius, __fzxBody(index).shape.radius
  fzxVector2DSet vert(1), -__fzxBody(index).shape.radius, -__fzxBody(index).shape.radius
  fzxVector2DSet vert(2), __fzxBody(index).shape.radius, -__fzxBody(index).shape.radius
  fzxVector2DSet vert(3), __fzxBody(index).shape.radius, __fzxBody(index).shape.radius
  fzxWorldToCamera index, vert(0)
  fzxWorldToCamera index, vert(1)
  fzxWorldToCamera index, vert(2)
  fzxWorldToCamera index, vert(3)
  glDrawTexturedQuad3d textures(__fzxBody(index).shape.texture).glText, vert(3), vert(0), vert(1), vert(2), z
END SUB


SUB renderTexturedBox (index AS INTEGER, textures() AS tGL_TEXTURE)
  DIM vert(3) AS tFZX_VECTOR2d

  fzxGetBodyVert index, 0, vert(0)
  fzxVector2DAddVector vert(0), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(0), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(0)

  fzxGetBodyVert index, 1, vert(1)
  fzxVector2DAddVector vert(1), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(1), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(1)

  fzxGetBodyVert index, 2, vert(2)
  fzxVector2DAddVector vert(2), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(2), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(2)

  fzxGetBodyVert index, 3, vert(3)
  fzxVector2DAddVector vert(3), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(3), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(3)

  glDrawTexturedQuad textures(__fzxBody(index).shape.texture).glText, vert(1), vert(2), vert(3), vert(0)
END SUB

SUB renderTexturedBox3d (index AS INTEGER, textures() AS tGL_TEXTURE, z AS DOUBLE)
  DIM vert(3) AS tFZX_VECTOR2d

  fzxGetBodyVert index, 0, vert(0)
  fzxVector2DAddVector vert(0), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(0), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(0)

  fzxGetBodyVert index, 1, vert(1)
  fzxVector2DAddVector vert(1), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(1), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(1)

  fzxGetBodyVert index, 2, vert(2)
  fzxVector2DAddVector vert(2), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(2), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(2)

  fzxGetBodyVert index, 3, vert(3)
  fzxVector2DAddVector vert(3), __fzxBody(index).shape.offsetTexture
  fzxVector2DMultiplyVector vert(3), __fzxBody(index).shape.scaleTexture
  fzxWorldToCamera index, vert(3)

  glDrawTexturedQuad3d textures(__fzxBody(index).shape.texture).glText, vert(1), vert(2), vert(3), vert(0), z
END SUB


SUB glStuff
  _GLMATRIXMODE _GL_PROJECTION 'Select The Projection Matrix
  _GLENABLE _GL_DEPTH_TEST 'use the zbuffer
  _GLLOADIDENTITY 'Reset The Projection Matrix
  _GLORTHO 0, _WIDTH(0), _HEIGHT(0), 0, -1, 1

  _GLCLEARCOLOR .01, .24, .01, .5

  _GLMATRIXMODE _GL_MODELVIEW 'Select The Modelview Matrix
  _GLLOADIDENTITY 'Reset The Modelview Matrix
  _GLCLEAR _GL_DEPTH_BUFFER_BIT OR _GL_COLOR_BUFFER_BIT

  _GLENABLE _GL_BLEND
  _GLBLENDFUNC _GL_SRC_ALPHA, _GL_ONE_MINUS_SRC_ALPHA 'how alpha values are interpretted
  _GLDEPTHMASK _GL_TRUE
  _GLALPHAFUNC _GL_GREATER, 0.5 'dont do anything if alpha isn't greater than 0.5 (or 128)
  _GLENABLE _GL_ALPHA_TEST

  _GLHINT _GL_LINE_SMOOTH_HINT, _GL_NICEST
  _GLHINT _GL_POLYGON_SMOOTH_HINT, _GL_NICEST
  _GLDISABLE _GL_LINE_SMOOTH
  _GLDISABLE _GL_POLYGON_SMOOTH
  _GLENABLE _GL_MULTISAMPLE
  $IF GLLIGHTS = TRUE THEN

      _GLENABLE _GL_LIGHTING

      _GLLIGHTMODELI _GL_LIGHT_MODEL_LOCAL_VIEWER, 1
      _GLMATERIALI _GL_FRONT_AND_BACK, _GL_SHININESS, 32
      STATIC theta AS SINGLE
      STATIC cm AS _MEM
      STATIC ps AS _MEM
      STATIC AS DOUBLE x, y, z, x1, y1, z1
      IF _KEYHIT THEN
      x = RND * 10 - 5
      y = RND * 10 - 5
      z = RND * 10 - 5
      x1 = RND * 10 - 5
      y1 = RND * 10 - 5
      z1 = RND * 10 - 5
      END IF

      cm = _MEMNEW(16)
      ps = _MEMNEW(16)
      glRGBColor cm, _RGB32(250, 250, 250)
      _GLLIGHTFV _GL_LIGHT0, _GL_DIFFUSE, cm.OFFSET
      _GLLIGHTFV _GL_LIGHT0, _GL_SPECULAR, cm.OFFSET
      'glFloat4 ps, x, y, z, 0
      glFloat4 ps, SIN(theta) * 2, COS(theta * 2), 2, 0
      _GLLIGHTFV _GL_LIGHT0, _GL_POSITION, ps.OFFSET

      _GLLIGHTF _GL_LIGHT0, _GL_CONSTANT_ATTENUATION, 2.0
      _GLLIGHTF _GL_LIGHT0, _GL_LINEAR_ATTENUATION, 1.0
      _GLLIGHTF _GL_LIGHT0, _GL_QUADRATIC_ATTENUATION, 0.5

      _GLLIGHTF _GL_LIGHT0, _GL_SPOT_CUTOFF, 45.0

      ' glFloat4 ps, x1, y1, z1, 0
      glFloat4 ps, -2, -2, -2, 0
      _GLLIGHTFV _GL_LIGHT0, _GL_SPOT_DIRECTION, ps.OFFSET

      _MEMFREE cm
      _MEMFREE ps

      _GLENABLE _GL_LIGHT0

      'cm = _MEMNEW(16)
      'ps = _MEMNEW(16)

      'glRGBColor cm, _RGB32(64, 6, 11)
      '_GLMATERIALFV _GL_FRONT, _GL_EMISSION, cm.OFFSET
      '_GLLIGHTFV _GL_LIGHT1, _GL_AMBIENT, cm.OFFSET
      '_GLLIGHTFV _GL_LIGHT1, _GL_DIFFUSE, cm.OFFSET
      '_GLLIGHTFV _GL_LIGHT1, _GL_SPECULAR, cm.OFFSET
      ''glFloat4 (ptr AS _MEM, x AS SINGLE, y AS SINGLE, z AS SINGLE, w AS SINGLE)
      'glFloat4 ps, 0, 0, 0, 0
      '_GLLIGHTFV _GL_LIGHT1, _GL_POSITION, ps.OFFSET

      '_MEMFREE cm
      '_MEMFREE ps


      theta = theta + .02: IF theta > 2 * _PI THEN theta = 0
      'LOCATE 2: PRINT "theta :"; theta; " s:"; SIN(theta); " c:"; COS(theta)
      '  LOCATE 2: PRINT "x:"; x; " y:"; y; " z:"; z; " x1:"; x1; " y1:"; y1; " z1:"; z1
      LOCATE 2: PRINT USING "x: ##.# y: ##.# z: ##.# x1: ##.# y1: ##.# z1: ##.#"; x; y; z; x1; y1; z1
  $END IF
END SUB

SUB GLSelectTexture (texture AS LONG)
  _GLBINDTEXTURE _GL_TEXTURE_2D, texture
END SUB

FUNCTION GLImageToTexture (texture() AS tGL_TEXTURE, img AS LONG)
  IF img > -1 THEN ERROR 100: EXIT FUNCTION
  DIM AS LONG textureArrayIndex
  DIM AS _MEM mIMG
  mIMG = _MEMIMAGE(img)
  textureArrayIndex = UBOUND(texture)
  _GLGENTEXTURES 1, _OFFSET(texture(textureArrayIndex).glText)
  _GLBINDTEXTURE _GL_TEXTURE_2D, texture(textureArrayIndex).glText
  _GLTEXIMAGE2D _GL_TEXTURE_2D, 0, _GL_RGBA, _WIDTH(img), _HEIGHT(img), 0, &H80E1&&, _GL_UNSIGNED_BYTE, mIMG.OFFSET
  GLImageToTexture = textureArrayIndex
  REDIM _PRESERVE texture(textureArrayIndex + 1) AS tGL_TEXTURE
  _MEMFREE mIMG
  _FREEIMAGE img
END FUNCTION

'**********************************************************************************************
'   GL Drawing Subs
'**********************************************************************************************
SUB _______________GL_DRAWING: END SUB
SUB glRGBColor (ptr AS _MEM, rgba AS LONG)
  DIM AS SINGLE r, g, b, a
  IF ptr.SIZE = 16 THEN
    r = fzxScalarMap(_RED(rgba), 0, 255, 0, 1)
    g = fzxScalarMap(_GREEN(rgba), 0, 255, 0, 1)
    b = fzxScalarMap(_BLUE(rgba), 0, 255, 0, 1)
    a = fzxScalarMap(_ALPHA(rgba), 0, 255, 0, 1)
    _MEMPUT ptr, ptr.OFFSET + 0, r AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 4, g AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 8, b AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 12, a AS SINGLE
  END IF
END SUB

SUB glFloat4 (ptr AS _MEM, x AS SINGLE, y AS SINGLE, z AS SINGLE, w AS SINGLE)
  IF ptr.SIZE = 16 THEN
    _MEMPUT ptr, ptr.OFFSET + 0, x AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 4, y AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 8, z AS SINGLE
    _MEMPUT ptr, ptr.OFFSET + 12, w AS SINGLE
  END IF
END SUB

SUB glDrawCircle (cx AS DOUBLE, cy AS DOUBLE, r AS DOUBLE, c AS LONG, numOfSegments AS LONG)

  DIM AS LONG ii
  DIM AS DOUBLE x, y, rads

  rads = 2.0 * _PI / numOfSegments

  _GLCOLOR3UB _RED(c), _GREEN(c), _BLUE(c)
  _GLBEGIN _GL_LINE_LOOP
  DO WHILE ii <= numOfSegments
    x = r * COS(rads * ii)
    y = r * SIN(rads * ii)
    _GLVERTEX3F x + cx, y + cy, .5
    ii = ii + 1
  LOOP
  _GLEND
  _GLFLUSH

END SUB

SUB glDrawRectText (tex AS LONG, x AS DOUBLE, y AS DOUBLE, x1 AS DOUBLE, y1 AS DOUBLE)
  GLSelectTexture tex
  _GLENABLE _GL_TEXTURE_2D
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MAG_FILTER, _GL_NEAREST
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MIN_FILTER, _GL_NEAREST
  _GLBEGIN _GL_QUADS
  _GLTEXCOORD2F 1, 1: _GLVERTEX2F x, y1
  _GLTEXCOORD2F 0, 1: _GLVERTEX2F x1, y1
  _GLTEXCOORD2F 0, 0: _GLVERTEX2F x1, y
  _GLTEXCOORD2F 1, 0: _GLVERTEX2F x, y
  _GLEND
  _GLDISABLE _GL_TEXTURE_2D
END SUB

SUB glDrawRect3DText (tex AS LONG, x AS DOUBLE, y AS DOUBLE, x1 AS DOUBLE, y1 AS DOUBLE, z AS DOUBLE)
  GLSelectTexture tex
  _GLENABLE _GL_TEXTURE_2D
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MAG_FILTER, _GL_NEAREST
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MIN_FILTER, _GL_NEAREST
  _GLBEGIN _GL_QUADS
  _GLTEXCOORD2F 1, 1: _GLVERTEX3F x, y1, z
  _GLTEXCOORD2F 0, 1: _GLVERTEX3F x1, y1, z
  _GLTEXCOORD2F 0, 0: _GLVERTEX3F x1, y, z
  _GLTEXCOORD2F 1, 0: _GLVERTEX3F x, y, z
  _GLEND
  _GLDISABLE _GL_TEXTURE_2D
END SUB


SUB glDrawTexturedQuad (tex AS LONG, a AS tFZX_VECTOR2d, b AS tFZX_VECTOR2d, c AS tFZX_VECTOR2d, d AS tFZX_VECTOR2d)
  GLSelectTexture tex
  _GLENABLE _GL_TEXTURE_2D
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MAG_FILTER, _GL_NEAREST
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MIN_FILTER, _GL_NEAREST
  _GLBEGIN _GL_QUADS
  _GLTEXCOORD2F 1, 1: _GLVERTEX2F a.x, a.y
  _GLTEXCOORD2F 0, 1: _GLVERTEX2F b.x, b.y
  _GLTEXCOORD2F 0, 0: _GLVERTEX2F c.x, c.y
  _GLTEXCOORD2F 1, 0: _GLVERTEX2F d.x, d.y
  _GLEND
  _GLDISABLE _GL_TEXTURE_2D
END SUB

SUB glDrawTexturedQuad3d (tex AS LONG, a AS tFZX_VECTOR2d, b AS tFZX_VECTOR2d, c AS tFZX_VECTOR2d, d AS tFZX_VECTOR2d, z AS DOUBLE)
  GLSelectTexture tex
  _GLENABLE _GL_TEXTURE_2D
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MAG_FILTER, _GL_NEAREST
  _GLTEXPARAMETERI _GL_TEXTURE_2D, _GL_TEXTURE_MIN_FILTER, _GL_NEAREST
  _GLBEGIN _GL_QUADS
  _GLTEXCOORD2F 1, 1: _GLVERTEX3F a.x, a.y, z
  _GLTEXCOORD2F 0, 1: _GLVERTEX3F b.x, b.y, z
  _GLTEXCOORD2F 0, 0: _GLVERTEX3F c.x, c.y, z
  _GLTEXCOORD2F 1, 0: _GLVERTEX3F d.x, d.y, z
  _GLEND
  _GLDISABLE _GL_TEXTURE_2D
END SUB


SUB glDrawLine (a AS tFZX_VECTOR2d, b AS tFZX_VECTOR2d, c AS LONG, w AS INTEGER)
  _GLLINEWIDTH w
  _GLCOLOR3UB _RED(c), _GREEN(c), _BLUE(c)
  _GLBEGIN _GL_LINES
  _GLVERTEX2F a.x, a.y
  _GLVERTEX2F b.x, b.y
  _GLEND
END SUB


'SUB pushStackGLTexture (stack() AS tGL_TEXTURE, element AS tGL_TEXTURE)
'  stack(UBOUND(stack)) = element
'  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS tGL_TEXTURE
'END SUB

'SUB popStackGlTexture (stack() AS tGL_TEXTURE)
'  IF UBOUND(stack) > 0 THEN REDIM _PRESERVE stack(UBOUND(stack) - 1) AS tGL_TEXTURE
'END SUB

'
'**********************************************************************************************
'   Generate Bitmap
'**********************************************************************************************

SUB loadSprites (bm() AS LONG)
  'Body  - License CC0 - GameArt2D.com
  DIM AS LONG b, temp
  bm(0) = _LOADIMAGE(_CWD$ + "/Assets/truck/Body.png")
  bm(1) = _LOADIMAGE(_CWD$ + "/Assets/truck/Wheel (1).png")
  bm(2) = _LOADIMAGE(_CWD$ + "/Assets/truck/Head.png")
  bm(3) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (2).png")
  bm(4) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/Crate.png")

  bm(5) = _LOADIMAGE(_CWD$ + "/Assets/orc/Body.png")
  bm(6) = _LOADIMAGE(_CWD$ + "/Assets/orc/Wheel (1).png")
  bm(7) = _LOADIMAGE(_CWD$ + "/Assets/orc/Head.png")

  bm(8) = _LOADIMAGE(_CWD$ + "/Assets/girl/Body.png")
  bm(9) = _LOADIMAGE(_CWD$ + "/Assets/girl/Wheel (1).png")
  bm(10) = _LOADIMAGE(_CWD$ + "/Assets/girl/Head.png")

  bm(11) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/BG.png")
  bm(12) = _LOADIMAGE(_CWD$ + "/Assets/Desert/png/Objects/Cactus (2).png")
  bm(13) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/ArrowSign.png")
  bm(14) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/Bush (1).png")
  bm(15) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/Bush (2).png")
  bm(16) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/DeadBush.png")
  bm(17) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/Skeleton.png")
  bm(18) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/TombStone (1).png")
  bm(19) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/TombStone (2).png")
  bm(20) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Objects/Tree.png")
  bm(21) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Bones (1).png")
  bm(22) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Bones (2).png")
  bm(23) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Bones (3).png")
  bm(24) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Bones (4).png")

  bm(25) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (1).png")
  bm(26) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (3).png")
  bm(27) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (4).png")
  bm(28) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (5).png")
  bm(29) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (6).png")
  bm(30) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (7).png")
  bm(31) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (8).png")
  bm(32) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (9).png")
  bm(33) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (10).png")
  bm(34) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (11).png")
  bm(35) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (12).png")
  bm(36) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (13).png")
  bm(37) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (14).png")
  bm(38) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (15).png")
  bm(39) = _LOADIMAGE(_CWD$ + "/Assets/Graveyard/png/Tiles/Tile (16).png")
  bm(40) = _LOADIMAGE(_CWD$ + "/Assets/Scifi/png/Tiles/Acid (1).png")
  bm(41) = _LOADIMAGE(_CWD$ + "/Assets/Scifi/png/Tiles/Acid (2).png")
  bm(42) = _LOADIMAGE(_CWD$ + "/Assets/Scifi/png/Tiles/Spike.png")
  FOR b = 0 TO 42
    IF bm(b) THEN temp = GLImageToTexture(textures(), bm(b))
  NEXT
END SUB



